//+------------------------------------------------------------------+
//|                                                       BarsHL.mq4 |
//|                                                        Taiyakixz |
//|              http://www.forexfactory.com/showthread.php?t=250781 |
//+------------------------------------------------------------------+
#property copyright "Taiyakixz"
#property link      "http://www.forexfactory.com/showthread.php?t=250781"

#property indicator_chart_window

extern int NumberOfBars = 5;
extern color LineColor = Yellow;
extern int TextShift = 10;
extern color TextColor = Orange;

string lineNameHigh = "[BarsHL]High";
string lineNameLow = "[BarsHL]Low";
string textNameHigh = "[BarsHL]High DateTime";
string textNameLow = "[BarsHL]Low DateTime";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   start();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete(lineNameHigh);
   ObjectDelete(lineNameLow);
   ObjectDelete(textNameHigh);
   ObjectDelete(textNameLow);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double curBarsHigh, curBarsLow;
   double tmpBarsHigh, tmpBarsLow;
   datetime dtBarsHigh, dtBarsLow;
   string label, tmpLabel, textMin;
   
   curBarsHigh = High[iHighest(NULL, 0, MODE_HIGH, NumberOfBars, 0)];
   dtBarsHigh = Time[iHighest(NULL, 0, MODE_HIGH, NumberOfBars, 0)];
   curBarsLow = Low[iLowest(NULL, 0, MODE_LOW, NumberOfBars, 0)];
   dtBarsLow = Time[iLowest(NULL, 0, MODE_LOW, NumberOfBars, 0)];
   
   if( ObjectFind(lineNameHigh) != 0 )
   {
     ObjectCreate(lineNameHigh, OBJ_HLINE, 0, Time[0], curBarsHigh);
     ObjectSet(lineNameHigh, OBJPROP_STYLE, STYLE_DOT);
     ObjectSet(lineNameHigh, OBJPROP_COLOR, LineColor);
     ObjectSet(lineNameHigh, OBJPROP_WIDTH, 1);
     label = StringConcatenate( "[",NumberOfBars, " bars High] ", TimeYear(dtBarsHigh), "/", TimeMonth(dtBarsHigh), "/", TimeDay(dtBarsHigh) );
     if( Period() < PERIOD_D1 )
     {
       if( TimeMinute(dtBarsHigh) < 10 ) textMin = StringConcatenate( "0", TimeMinute(dtBarsHigh) );
       else textMin = TimeMinute(dtBarsHigh);
       label = StringConcatenate( label, " ", TimeHour(dtBarsHigh), ":", textMin );
     }
     ObjectCreate(textNameHigh, OBJ_TEXT, 0, Time[0]+TextShift*Period()*60, curBarsHigh);
     ObjectSetText(textNameHigh, label, 8, "Arial", TextColor);
   }
   else
   {
     tmpBarsHigh = ObjectGet(lineNameHigh, OBJPROP_PRICE1);
     if( tmpBarsHigh != curBarsHigh )
     {
       ObjectMove(lineNameHigh, 0, Time[0], curBarsHigh);
       ObjectMove(textNameHigh, 0, Time[0]+TextShift*Period()*60, curBarsHigh);
     }
     label = StringConcatenate( "[",NumberOfBars, " bars High] ", TimeYear(dtBarsHigh), "/", TimeMonth(dtBarsHigh), "/", TimeDay(dtBarsHigh) );
     if( Period() < PERIOD_D1 )
     {
       if( TimeMinute(dtBarsHigh) < 10 ) textMin = StringConcatenate( "0", TimeMinute(dtBarsHigh) );
       else textMin = TimeMinute(dtBarsHigh);
       label = StringConcatenate( label, " ", TimeHour(dtBarsHigh), ":", textMin );
     }
     tmpLabel = ObjectDescription( textNameHigh );
     if(tmpLabel != label)
       ObjectSetText(textNameHigh, label, 8, "Arial", TextColor);
   }
   
   if( ObjectFind(lineNameLow) != 0 )
   {
     ObjectCreate(lineNameLow, OBJ_HLINE, 0, Time[0], curBarsLow);
     ObjectSet(lineNameLow, OBJPROP_STYLE, STYLE_DOT);
     ObjectSet(lineNameLow, OBJPROP_COLOR, LineColor);
     ObjectSet(lineNameLow, OBJPROP_WIDTH, 1);
     label = StringConcatenate( "[",NumberOfBars, " bars Low] ", TimeYear(dtBarsLow), "/", TimeMonth(dtBarsLow), "/", TimeDay(dtBarsLow) );
     if( Period() < PERIOD_D1 )
     {
       if( TimeMinute(dtBarsLow) < 10 ) textMin = StringConcatenate( "0", TimeMinute(dtBarsLow) );
       else textMin = TimeMinute(dtBarsLow);
       label = StringConcatenate( label, " ", TimeHour(dtBarsLow), ":", textMin );
     }
     ObjectCreate(textNameLow, OBJ_TEXT, 0, Time[0]+TextShift*Period()*60, curBarsLow);
     ObjectSetText(textNameLow, label, 8, "Arial", TextColor);
   }
   else
   {
     tmpBarsLow = ObjectGet(lineNameLow, OBJPROP_PRICE1);
     if( tmpBarsLow != curBarsLow )
     {
       ObjectMove(lineNameLow, 0, Time[0], curBarsLow);
       ObjectMove(textNameLow, 0, Time[0]+TextShift*Period()*60, curBarsLow);
     }

     label = StringConcatenate( "[",NumberOfBars, " bars Low] ", TimeYear(dtBarsLow), "/", TimeMonth(dtBarsLow), "/", TimeDay(dtBarsLow) );
     if( Period() < PERIOD_D1 )
     {
       if( TimeMinute(dtBarsLow) < 10 ) textMin = StringConcatenate( "0", TimeMinute(dtBarsLow) );
       else textMin = TimeMinute(dtBarsLow);
       label = StringConcatenate( label, " ", TimeHour(dtBarsLow), ":", textMin );
     }
     tmpLabel = ObjectDescription( textNameLow );
     if(tmpLabel != label)
       ObjectSetText(textNameLow, label, 8, "Arial", TextColor);
   }
   
   return(0);
  }
//+------------------------------------------------------------------+